/**********************************************************************************
 * $URL: https://source.sakaiproject.org/svn/sakai-mock/tags/sakai-mock-2.9.1/src/main/java/org/sakaiproject/mock/domain/Tool.java $
 * $Id: Tool.java 59684 2009-04-03 23:33:27Z arwhyte@umich.edu $
 ***********************************************************************************
 *
 * Copyright (c) 2007, 2008 The Sakai Foundation
 *
 * Licensed under the Educational Community License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 **********************************************************************************/
package org.sakaiproject.mock.domain;

import java.util.Properties;
import java.util.Set;

public class Tool implements org.sakaiproject.tool.api.Tool {
	String id;
	String home;
	String title;
	String description;
	Set<String> categories;
	Set<String> keywords;
	Properties mutableConfig;
	Properties registeredConfig;
	Properties finalConfig;
	
	public AccessSecurity getAccessSecurity() {
		return AccessSecurity.TOOL;
	}

	public Set<String> getCategories() {
		return categories;
	}

	public void setCategories(Set<String> categories) {
		this.categories = categories;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public Properties getFinalConfig() {
		return finalConfig;
	}

	public void setFinalConfig(Properties finalConfig) {
		this.finalConfig = finalConfig;
	}

	public String getHome() {
		return home;
	}

	public void setHome(String home) {
		this.home = home;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public Set<String> getKeywords() {
		return keywords;
	}

	public void setKeywords(Set<String> keywords) {
		this.keywords = keywords;
	}

	public Properties getMutableConfig() {
		return mutableConfig;
	}

	public void setMutableConfig(Properties mutableConfig) {
		this.mutableConfig = mutableConfig;
	}

	public Properties getRegisteredConfig() {
		return registeredConfig;
	}

	public void setRegisteredConfig(Properties registeredConfig) {
		this.registeredConfig = registeredConfig;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}


}
